'''
Created on Aug 23, 2010

@author: Dummey
'''
import pyglet
import math
import random

NORTH = 90
WEST = 180
SOUTH = 270
EAST = 0

hipster_image = [pyglet.image.load("data/hipster.png"),
                 pyglet.image.load("data/hipster2.png"),
                 pyglet.image.load("data/hipster3.png"),
                 pyglet.image.load("data/hipster4.png"),
                 pyglet.image.load("data/hipster5.png"),]
hipster_batch = pyglet.graphics.Batch()

speeds = [1, 2, 3, 4, 5, 6, 7, 8, 9]

class Hipsters():
    
    def __init__(self):
        self.hipsters = []
        
    def add_hipster(self, x, y):
        self.hipsters.append(Hipster(x, y, hipster_batch))
        
    def get_hipsters(self):
        return self.hipsters
    
    def kill_hipster(self, hipster):
        try:
            self.hipsters.remove(hipster)
            hipster.die()
        except:
            pass
        
    def update(self):
        for hipster in self.hipsters:
            hipster.update()
        
    def on_draw(self):
        hipster_batch.draw()

    
class Hipster(pyglet.sprite.Sprite):
    speedup_distance = 5
    following = False
    
    def __init__(self, x, y, batch, speed = 1):
        pyglet.sprite.Sprite.__init__(self, random.choice(hipster_image), batch=batch)
        self.image.anchor_x = self.image.width / 2
        self.image.anchor_y = self.image.height / 2
        self.straights = 0
        self.change_direction(0)
        self.x = x
        self.y = y
        self.speed_setting = speed
        if speed is None:
            self.speed = speeds[self.speed_setting]
        else:
            self.speed = speed
    
    def update(self):
        if self.straights >= self.speedup_distance and self.speed_setting + 1 < len(speeds):
            self.straights = 0
            self.speed_setting += 1
            self.speed = speeds[self.speed_setting]
            
        self.y += self.speed * math.sin(self.direction) * -1
        self.x += self.speed * math.cos(self.direction)

    def change_direction(self, new_dir):
        if self.rotation == new_dir:
            self.straights += 1
        self.rotation = new_dir
        self.direction = math.radians(self.rotation)
        
    def die(self):
        self.following = False
        self.delete()
    
    def on_draw(self):
        self.draw()
    