import pyglet
import shared.util as util
from shared.scene import Scene

main_bg = pyglet.image.load('data/main.png')

class Home(Scene):
    next_state = None
    start_game = pyglet.text.Label('Story Mode',
                          font_name='Segoe Script',
                          font_size=36,
                          x=400, y=100,
                          height = 72,
                          width = 200,
                          anchor_x='center',
                          anchor_y='center',
                          color=(0,0,0,255))
    def __init__(self):
        media = pyglet.resource.media('data/easy_run.mp3', streaming=False)
        self.player = pyglet.media.Player()
        self.player.queue(media)
        self.player.eos_action = pyglet.media.Player.EOS_LOOP
        self.player.play()
    
    def on_mouse_motion(self, x, y, dx, dy):
        if util.intersects_label(x, y, self.start_game):
            self.start_game.bold = True
        else:
            self.start_game.bold = False
            
    def on_mouse_press(self, x, y, button, modifiers):
        if util.intersects_label(x, y, self.start_game):
            self.next_state = True
    
    def on_draw(self):
        main_bg.blit(0,0)
        self.start_game.draw()
        
    def update(self):
        if self.next_state: 
            import scenes.manager as Manager
            tmp = self.next_state
            self.next_state = None
            self.player.pause()
            Manager.goto_level(0)
        return False
        
    